package esercizio2;
import java.util.*;
public class GestoreTelefonico{

	private static final int MAX_TARIFFE=15;
	private Map<String,Tariffa> tariffeUtenti;
	private Tariffa[] tariffe;
    private int numTariffe;
	private Set<Telefonata> telefonate;
	
	public GestoreTelefonico(){
		tariffeUtenti=new HashMap<String,Tariffa>();
		tariffe=new Tariffa[MAX_TARIFFE];
		numTariffe=0;
		telefonate = new HashSet<Telefonata>();
	}
	
	
	public Tariffa cercaTariffa(String nome){
		boolean trovato=false;
		Tariffa t = null;
		for(int i=0;i<numTariffe && !trovato;i++){
			if(tariffe[i].getNome().equals(nome)){
				trovato=true;
				t=tariffe[i];
			}
		}
		return t;
	}
	
    public void registraUtente(String utente, String nomeTariffa){
		Tariffa t = cercaTariffa(nomeTariffa);
		tariffeUtenti.put(utente, t);
	}
	
	public List<Telefonata> telefonateMensili(String utente, String mese){
		List<Telefonata> telefonateMensili = new ArrayList<Telefonata>();
		Iterator<Telefonata> it = telefonate.iterator();
		while(it.hasNext()){
			Telefonata t = it.next();
			if(t.getSorgente().equals(utente) && t.getData().endsWith(mese)){
				telefonateMensili.add(t);
			}
		}
		return telefonateMensili;
	}
	
	public double calcolaCostoMensile(String utente, String mese){
		double importo=0;
		Tariffa t = tariffeUtenti.get(utente);
		if(t instanceof Flat){
			
			Flat f = (Flat)t;
			importo = f.getCanoneMensile();
		}
		else{
			Minuti m = (Minuti)t;
			List<Telefonata> telefonate = telefonateMensili(utente, mese);
			for(int i=0;i<telefonate.size();i++){
				Telefonata tel = telefonate.get(i);
				importo += tel.getDurata()*m.getCostoAlMinuto()+ m.getScattoAllaRisposta();
			}
		}
		return importo;
	}
	
	
	/*
	 * metodi getter e setter necessari solo al funzionamento del programma principale
	 */
	public int getNumTariffe() {
		return numTariffe;
	}
	public Tariffa[] getTariffe() {
		return tariffe;
	}

	public Set<Telefonata> getTelefonate() {
		return telefonate;
	}
	public void setNumTariffe(int numTariffe) {
		this.numTariffe = numTariffe;
	}
	public void setTariffe(Tariffa[] tariffe) {
		this.tariffe = tariffe;
	}
}
